import java.net.*;
import java.io.*;
import java.util.*;


///////////////////////////////////////////////////////////////////////////////
// 
// Calculates average and standard deviation for Vector of doubles
//
///////////////////////////////////////////////////////////////////////////////
class StatVector extends Vector
{
    // add double to vector ===================================================
    synchronized void addDouble( double elem )
    {
        addElement( new Double(elem) );
    }

    // calculate stat moments of the vector values ============================
    synchronized StatMoments getStatMoments() 
    {   Double val;
        double sum  = 0.;
        double sum2 = 0.;

        Enumeration enum = elements();
        while ( enum.hasMoreElements() ) {
            val   = (Double)(enum.nextElement());

            sum  += val.doubleValue();
            sum2 += val.doubleValue() * val.doubleValue();
        }

        StatMoments m = new StatMoments();
        
        int n    = size();
        m.avg    = sum / n;
        m.stdDev = (n > 1) ? Math.sqrt( (sum2 - sum * sum / n) / (n - 1) ) 
                           : 0.;
  
        return m;      
    }

    // print all elements of a stat. vector ===================================
    void print()
    {
        Double lat;
        StatMoments m;
        
        m = getStatMoments();
        
        System.out.print( " " );

        for ( Enumeration e = elements();
              e.hasMoreElements(); ) {

             lat = (Double) e.nextElement(); 
             System.out.print( lat + " " );
        }
        
        try {
            System.out.print( " " + 
                              Webpp.PERCENTILE + 
                              "-percentile: " + 
                              m.getPercentile(Webpp.PERCENTILE, 
                                              Webpp.STAT_SIZE) +
                              " " );
        } catch( Exception e ){
            System.out.print(  " " + 
                               Webpp.PERCENTILE +
                               "-percentile: except" );
        }
    }
}





