package webppserv;

import java.io.*;
import java.lang.*;
import java.util.*;

class MessageBroadcaster extends Thread implements Runnable
{
  String msgType, param;

  public MessageBroadcaster(String msgType, String param)
  {
	this.msgType = msgType;
	this.param = param;
  }

  public void run()
  {
	String serverName, port;
        Enumeration enum;
        ThreadGroup msgTG    = new ThreadGroup("Message Group");

	yield();	// give the caller a chance to go on

	// if this is initialization msg for AliveServers, then wait
	//	10 secs and give them a chance to start operating.
	//if (msgType.equalsIgnoreCase("AliveServers")) {
	//  try {
	//    sleep(10000);
	//  } catch (InterruptedException ie) {}
	//}

	Webpp.msgCount = 0;
        enum = Webpp.serverPorts.keys();
        while( enum.hasMoreElements() ) {
          serverName = (String) enum.nextElement();
          if (serverName == null) return;
          if (serverName.equals(Webpp.server) || !Webpp.serverIsAlive(serverName))
	    continue;  		// don't send messages to yourself or dead servers
	  port = (String) Webpp.serverPorts.get(serverName);
          Runnable r = new SendMsg(serverName + ":" + port, msgType, param);
          Thread t = new Thread(msgTG, r);
          t.start();
          Webpp.msgCount++;
        }
        while (Webpp.msgCount > 0) {
	  try {
	    sleep(100);
	  } catch (InterruptedException ie) {}
	}

        System.out.println("Broadcast is finished for " + msgType);
  }

}
