package webppserv;

import java.io.*;
import java.lang.*;
import java.net.*;

class SendMsg extends Thread
{
  String serverName, msgType, param;

  public SendMsg(String serverName, String msgType, String param) {
    this.serverName = serverName;
    this.msgType = msgType;
    this.param = param;
  }

  public void run() {
    yield();	// give the caller a chance to go on
    try {
      postURL(serverName, msgType, param);
    } catch (Exception e) {
      System.out.println("Problem while sending " +  msgType + " message to " + serverName);
    }
    Webpp.msgCount--;
  }

  public static void postURL(String serverName, String msgType, String param) throws Exception {
    byte b = 0;
    int done = 0, bytesRead;
    String urlName = "http://" + serverName + "/servlet/webppserv.Webpp/?" + msgType;
    URL url = new URL(urlName);
    HttpURLConnection conn = (HttpURLConnection) url.openConnection();
    
    conn.setRequestMethod("POST");
    bytesRead = 0;

    // Send your Post message
    if (param != null)
      conn.setRequestProperty("param", param);

    // Get the response
    DataInputStream in = new DataInputStream(conn.getInputStream());
    try { b = in.readByte(); } catch (EOFException e) { done = 1; }
    while (done == 0) {
      bytesRead++;
      try { b = in.readByte(); } catch (EOFException e) { done = 1; }
    }
    in.close();
  }

}
